      subroutine ffsmd_qp(g,u1,u2,u,mat)
c----------------------------------------------------------------------c
c Returns a matrix element
c           u=u1*(gm*P- + gp*P+)*u2*u
c Input: g - a fermion-fermion-scalar boson coupling.
c        u1,u2 - spinors,
c        u - scalar.
c The gamma matrices are taken in the Weyl representation as in the 
c paper by K. Kolodziej, M. Zralek, Phys. Rev. D43 (1991) 3619
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 15 May, 2007; modified 
c 23 Feb. 2021: QP version
c----------------------------------------------------------------------c

      implicit none

      complex(kind(1.d0)) :: g(2)
      complex(kind(1.q0)) :: u1(4),u2(4),u,mat

      mat=(g(2)*(u1(1)*u2(1)+u1(2)*u2(2))
     &       +g(1)*(u1(3)*u2(3)+u1(4)*u2(4)))*u

      end subroutine ffsmd_qp
