      subroutine vsvmd_qp(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element array for the triple gauge-Higgs boson  
c coupling
c
c Input: u1,u2 - vectors,
c        u3 -scalar
c        g - a Higgs-gauge-boson coupling.
c All four momenta are cosidered as incoming to the vertex.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 14 May, 2007; modified 
c 23 Feb. 2021: QP version
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0),qp=kind(1.q0)
      complex(dp) :: g
      complex(qp) :: u1(0:3),u3(0:3),u2,mat

      mat=g*u2*(u1(0)*u3(0)-u1(1)*u3(1)-u1(2)*u3(2)-u1(3)*u3(3))

      end subroutine vsvmd_qp
