      subroutine bbmd(iwgt,wgt,arg,mass,g,p,u1,u2,mat)
c----------------------------------------------------------------------c
c Returns a matrix element for the vector-vector mixing
c
c Input: iwgt = 1 => include a factor wgt*e^(i*arg)*s/mass**2,
c               else => do not include the factor,
c        g - a double vector-vector coupling,
c        p - four momentum of u1 and u2, 
c        u1,u2 - vectors
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 9 April, 2014; modified on 4 March, 2015
c 24 March, 2015:
c a call to subroutine weightfactor introduced
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)
      integer :: iwgt
      real(dp) :: wgt,arg,mass
      real(dp), dimension(0:3) :: p
      complex(dp), dimension(0:3) :: u1,u2
      complex(dp) :: g,mat,cfac

      mat=g*(u1(0)*u2(0)-u1(1)*u2(1)-u1(2)*u2(2)-u1(3)*u2(3))

      if (iwgt > 0) then
       call weightfactor(iwgt,wgt,arg,p,mass,cfac)
       mat=cfac*mat
      end if

      end subroutine bbmd
