      subroutine ggggmd_qp(iv,g,u1,u2,u3,u4,mat)
c----------------------------------------------------------------------c
c Returns a generalized polarization vector being a contraction of
c a quartic gluon vertex with three polarization vectors
c
c Input: u1,u2,u3,u4 - polarization vectors,
c        g - a quartic gluon coupling.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 18 May, 2007; modified on 
c 23 Feb. 2021: QP version
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0),qp=kind(1.q0)
      integer :: iv
      complex(dp) :: g
      complex(qp) :: mat
      complex(qp), dimension(0:3) :: u1,u2,u3,u4,u

      if (iv == 1) then
       u=-g*((u2(0)*u3(0)-u2(1)*u3(1)-u2(2)*u3(2)
     &                               -u2(3)*u3(3))*u1
     &      -(u1(0)*u3(0)-u1(1)*u3(1)-u1(2)*u3(2)
     &                               -u1(3)*u3(3))*u2)
      else if (iv == 2) then
       u=-g*((u1(0)*u3(0)-u1(1)*u3(1)-u1(2)*u3(2)
     &                               -u1(3)*u3(3))*u2
     &      -(u1(0)*u2(0)-u1(1)*u2(1)-u1(2)*u2(2)
     &                               -u1(3)*u2(3))*u3)
      else if (iv == 3) then
       u=-g*((u1(0)*u2(0)-u1(1)*u2(1)-u1(2)*u2(2)
     &                               -u1(3)*u2(3))*u3
     &      -(u3(0)*u2(0)-u3(1)*u2(1)-u3(2)*u2(2)
     &                               -u3(3)*u2(3))*u1)
      else

      write(*,*)'ggggmd_qp.f: Wrong value of iv',iv

      end if

      mat=u(0)*u4(0)-u(1)*u4(1)-u(2)*u4(2)-u(3)*u4(3)

      end subroutine ggggmd_qp
