      subroutine ix5(next,nexh,nhel,n,indx)
c----------------------------------------------------------------------c
c Rearranges elements of the building block arrays into a correct order,
c for up to 12 particles
c
c Input: next - No of eternal particles,
c        nexh - No of polarization states of external particles,
c        nhel - No of all helicity states,
c        n(npart) - permutation of npart external particles
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 29 May, 2007; modified on 
c----------------------------------------------------------------------c

      implicit none

      integer :: next,nexh(next),nhel,
     &           i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,
     &           k1,k2,k3,k4,k5,
     &           indx(nhel),ix,i,ii(12)

      integer, dimension(next) :: nn
      integer, dimension(5) :: j,n
      integer, dimension(4) :: d
 
      do i=1,next
       nn(i)=nexh(i)
      end do

      j=0
      ix=0

      if (next == 7) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)

      ix=ix+1

      ii(1:7)=(/i1,i2,i3,i4,i5,i6,i7/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)


      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 8) then


      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)

      ix=ix+1

      ii(1:8)=(/i1,i2,i3,i4,i5,i6,i7,i8/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 9) then


      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)

      ix=ix+1

      ii(1:9)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 10) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)
      do i10=1,nn(10)

      ix=ix+1

      ii(1:10)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9,i10/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 11) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)
      do i10=1,nn(10)
      do i11=1,nn(11)

      ix=ix+1

      ii(1:11)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 12) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)
      do i10=1,nn(10)
      do i11=1,nn(11)
      do i12=1,nn(12)

      ix=ix+1

      ii(1:12)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else 

      write(*,*)'ix5.f: This value of next is not yet implemented',next

      end if


      end




