      subroutine sssmd_qp(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element array for a triple scalar boson coupling
c contracte with 3 scalars
c
c Input: u1,u2,u3 - sclars,
c        g - a triple scalar boson coupling.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 17 May, 2007; modified 
c 23 Feb. 2021: QP version
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0),qp=kind(1.q0)
      complex(dp) :: g
      complex(qp) :: u1(1),u2(1),u3(1),mat

      mat=g*u1(1)*u2(1)*u3(1)

      end subroutine sssmd_qp
