      function cs_sect(x,ndim)
c----------------------------------------------------------------------c
c The unpolarized cross section
c
c Input:  x(ndim) - random numbers supplied by carlos.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 27 Oct., 2022, 
c modiffied on 
c----------------------------------------------------------------------c
      use inprms
      use drivekk
      use distribs
      use partcls
c      use prtinds
      use psnrmtest
      use ntdisc
      use fourmom

      implicit none

      integer :: ndim,i,istf,imxup=0

      real(kind(1.d0)) :: cs_sect,x(ndim),flux,dlips,
     &            mat2,phi(nmcs),p_dp(0:3,nepl),sumi(0:3),sumf(0:3),diff

      real :: y(nmcs),rand

      real(kind(1.d0)) :: x1,x2

      real(kind(1.d0)), parameter :: diff0=1.d-6

      save flux,imxup

      x1=1.d0
      x2=1.d0

      call psgen(ikin,ecm,x1,x2,x,ndim,flux,dlips)

      if (dlips > zero) then ! test
c MC summing over polarizations:
       if (nmcs > 0 .and. ips_vol /= 1) then
        if (irand == 1) then
         call random_number(y)
        else if (irand == 2) then
         call ranlux(y,nmcs)
        end if
        do i=1,nmcs
         phi(i)=twopi*y(i)
        end do
       end if

c Check four momentum conservation:

       sumi=p(:,1)+p(:,2)
       sumf=0
       do i=3,nepl
        sumf=sumf+p(:,i)
       end do

       diff=abs(sumi(0)-sumf(0))+abs(sumi(1)-sumf(1))
     &     +abs(sumi(2)-sumf(2))+abs(sumi(3)-sumf(3))

       if (diff > diff0) then
        cs_sect=0
        return
       end if

       if (iqprec == 1) then
        if (ips_vol == 1) then
         mat2=1.d0
        else
         call matrixel(phi,mat2)
        end if
       else
        if (ips_vol == 1) then
         mat2=1.d0
        else
         call matrixel(phi,mat2)
        end if
       end if

c       cs_sect=convc/flux*ralpw0*mat2*dlips
       cs_sect=convc/flux*mat2*dlips

       if (ipsnrm == 1) then
        cs_sect=cs_sect/dlips*dlipst
       end if

       icall=icall+1

       if (imc == 1) then
        if (cs_sect > crmax) then
         crmax=cs_sect
         if (iscan == 0) imxup=1
        end if
       end if

       if (idis == 1 .and. iscan == 0) then
        if (x1*x2 < 1.d0) then
         call calcdis(r_dp,cs_sect)
        else
         p_dp=p
         call calcdis(p_dp,cs_sect)
        end if
       end if

       if (imc == 1 .and. iscan == 0) then
        ieff=ieff+1
        write(11,*) cs_sect
        do i=nisp+1,nepl
         if (x1*x2 < 1.d0) then
          write(11,'(4(e16.8))') r_dp(:,i)
         else
          write(11,'(4(e16.8))') p(:,i)
         end if
        end do
       end if
      else
       cs_sect=zero
       ntd0=ntd0+1
       return
      end if  !  dlips

      end function cs_sect
